-- ===================================================================

minetest.register_node ("default:brick", {
    description = "Brick",
    tiles = { "default_brick.png" } ,
    is_ground_content = false,
    groups = {cracky=3},
    drop = 'default:brick',
    sounds = default.sound_stone(),
})

-- ===================================================================

minetest.register_node ("default:obsidian_glass", {
    description = "Obsidian Glass",
    drawtype = "glasslike_framed_optional",
    tiles = {"default_obsidian_glass.png",
             "default_obsidian_glass_detail.png"} ,
    paramtype = "light",
    is_ground_content = false,
    sunlight_propagates = true,
    sounds = default.sound_glass() ,
    groups = {cracky = 3} ,
})

-- ===================================================================

minetest.register_node ("default:goldblock", {
    description = "Gold Block",
    tiles = { "default_goldblock.png" } ,
    is_ground_content = false,
    groups = {cracky = 1},
    sounds = default.sound_stone(),
})

-- ===================================================================

minetest.register_node ("default:diamondblock", {
    description = "Diamond Block",
    tiles = { "default_diamondblock.png" } ,
    is_ground_content = false,
    groups = {cracky = 1, level = 3},
    sounds = default.sound_stone(),
})

-- ===================================================================

minetest.register_node ("default:glass", {
    description = "Glass",
    drawtype = "glasslike",
    tiles = { "default_glass.png" } ,
    paramtype = "light",
    is_ground_content = false,
    sunlight_propagates = true,
    groups = {snappy=2,cracky=3,oddly_breakable_by_hand=3},
    sounds = default.sound_glass(),
})

-- ===================================================================

minetest.register_node ("default:fence_wood", {
    description = "Wooden Fence",
    drawtype = "fencelike",
    tiles = { "default_wood.png" } ,
    inventory_image = "default_fence.png",
    wield_image = "default_fence.png",
    paramtype = "light",
    is_ground_content = false,
    selection_box = {
        type = "fixed",
        fixed = {-1/7, -1/2, -1/7, 1/7, 1/2, 1/7},
    },
    groups = {snappy=2,choppy=2,oddly_breakable_by_hand=2,wood=1},
    sounds = default.sound_wood(),
})

-- ===================================================================

minetest.register_node ("default:torch", {
    description = "Torch",
    drawtype = "plantlike",
    tiles = { "default_torch_on_floor.png", "default_torch_on_ceiling.png", "default_torch.png" } ,
    inventory_image = "default_torch_on_floor.png",
    wield_image = "default_torch_on_floor.png",
    paramtype = "light",
    paramtype2 = "wallmounted",
    sunlight_propagates = true,
    is_ground_content = false,
    walkable = false,
    light_source = default.LIGHT_MAX-1,
    selection_box = {
        type = "wallmounted",
        wall_top = {-0.1, 0.5-0.6, -0.1, 0.1, 0.5, 0.1},
        wall_bottom = {-0.1, -0.5, -0.1, 0.1, -0.5+0.6, 0.1},
        wall_side = {-0.5, -0.3, -0.1, -0.5+0.3, 0.3, 0.1},
    },
    groups = {choppy=2,dig_immediate=3,attached_node=1},
    legacy_wallmounted = true,
    sounds = default.node_sound_defaults(),
})

-- ===================================================================

minetest.register_node ("default:sign_wall", {
    description = "Sign",
    drawtype = "signlike",
    tiles = { "default_sign_wall.png" } ,
    inventory_image = "default_sign_wall.png",
    wield_image = "default_sign_wall.png",
    paramtype = "light",
    paramtype2 = "wallmounted",
    sunlight_propagates = true,
    is_ground_content = false,
    walkable = false,
    selection_box = {
        type = "wallmounted",
        --wall_top = <default>
        --wall_bottom = <default>
        --wall_side = <default>
    },
    groups = {choppy=2,dig_immediate=2,attached_node=1},
    legacy_wallmounted = true,
    sounds = default.node_sound_defaults(),
    on_construct = function(pos)
        --local n = minetest.get_node(pos)
        local meta = minetest.get_meta(pos)
        meta:set_string("formspec", "field[text;;${text}]")
        meta:set_string("infotext", "\"\"")
    end,
    on_receive_fields = function(pos, formname, fields, sender)
        --print("Sign at "..minetest.pos_to_string(pos).." got "..dump(fields))
        local meta = minetest.get_meta(pos)
        fields.text = fields.text or ""
        print((sender:get_player_name() or "").." wrote \""..fields.text..
                "\" to sign at "..minetest.pos_to_string(pos))
        meta:set_string("text", fields.text)
        meta:set_string("infotext", '"'..fields.text..'"')
    end,
})

-- ===================================================================

minetest.register_node ("default:steelblock", {
    description = "Steel Block",
    tiles = { "default_steelblock.png" } ,
    is_ground_content = false,
    groups = {snappy=1,bendy=2},
    sounds = default.sound_stone(),
})

-- ===================================================================
-- Crafting items

minetest.register_craftitem ("default:paper", {
    description = "Paper",
    inventory_image = "default_paper.png",
})

-- ===================================================================

node_name = "default:glowing_fungus"
img       = "default_glowing_fungus.png"
--
minetest.register_node (node_name, { 
    description     = "Glowing Fungus"  ,
    drawtype        = "plantlike"       ,
    paramtype       = "light"           ,
    tiles           = { img }           ,
    inventory_image =   img             ,

    groups          = {
        dig_immediate=3, attached_node=1
    } ,
})

-- ===================================================================
-- End of file.
