-- ===================================================================

local enable_moontest =
    minetest.setting_getbool ("enable_moon"     ) or
    minetest.setting_getbool ("enable_moontest" )

codersky       = {}
codersky.name  = nil
codersky.cspec = nil

local pos = { x=0, y=0, z=0 }

-- ===================================================================

local spaceskybox = {
    "sky_pos_y.jpg" ,
    "sky_neg_y.jpg" ,
    "sky_pos_z.jpg" ,
    "sky_neg_z.jpg" ,
    "sky_neg_x.jpg" ,
    "sky_pos_x.jpg" ,
}

-- ===================================================================

local function current_hour()
    return math.mod (math.floor (minetest.get_timeofday() * 24 + 0.5),
        24)
end

-- ===================================================================

local function current_time()
    return math.floor (minetest.get_timeofday() * 24000)
end

-- ===================================================================

codersky.set_sky = function (player, newspec, newname)

    if newspec ~= nil then
        codersky.cspec = { r=newspec.r, g=newspec.g, b=newspec.b }
        newname = nil
    end

    if newname == "skybox" then
        player:set_sky (nil, "skybox", spaceskybox)
    elseif (newname == "regular") or (codersky.cspec == nil) then
        player:set_sky (nil, "regular", nil)
        codersky.cspec = nil
    else
        player:set_sky (codersky.cspec, "plain", nil)
    end
end

-- ===================================================================

codersky.update_skybox = function (player)
    local name = player:get_player_name()
    local pos  = player:getpos()
    local gpbn = minetest.get_player_by_name (name)

    if not gpbn then return end
    local is_space = upper_realms.is_outer_space (pos.y)

    if is_space then
        player:set_physics_override (1, 0.6, 0.2)
        player:set_sky (nil, "skybox", spaceskybox)
    else
        player:set_physics_override (1, 1, 1)

        if (pos.y <= 1000) then
            codersky.set_sky (player, nil, nil)
        else
            player:set_sky (nil, "regular", nil)
        end
    end
end

-- ===================================================================

local time = 0

minetest.register_globalstep (function (dtime)
    time = time + dtime
    if time <= 1 then return end        

    for _, player in ipairs (minetest.get_connected_players()) do
        time = 0
        codersky.update_skybox (player)
    end
end)

-- ===================================================================

minetest.register_on_leaveplayer (function (player)
    local name = player:get_player_name()
    if name then
        codersky.set_sky (player, nil, "regular", true)
    end
end)
